/********************************************************************************
*	NOTICE:														*
*																*
*	This code is believed by the author to be bug free.  You are free to use	*
*	and modify this code with the understanding that any use, either direct	*
*	or derivative, must contain acknowledgement of its author and source.		*
*	The author makes no warranty of any kind, expressed or implied, of		*
*	merchantability or fitness for a particular purpose.  The author shall	*
*	not be held liable for any incidental or consequential damages in		*
*	connection with or arising out of the furnishing, performance, or use of	*
*	this software.  This software is not authorized for use in life support	*
*	devices or systems.												*
*																*
********************************************************************************/

// AIPP software developed by Gianluca Di Pasqua, John Oh, and Sean Hanley
// in association with the DSP Lab at the University of Toronto, 2000.

import java.awt.*;
import java.awt.image.*;
import java.io.*;

// Channels the red component of image
public class redfilt extends EffectFilter
{
	// Create object
	public redfilt()
	{
	}
	
	// Runs algorithm
	public void performEffect()
	{
		int newPixels[] = new int[width*height];
		int red = 0;
		
		// Moves through the input array pixel by pixel
		for(int k=0;k<width*height;k++)
		{
			// Isolates red component
			red = ((pixels[k]>>16)&0xff);
			
			// Outputs red component in greyscale
			newPixels[k] = (255<<24 | (red<<16) | (red<<8) | red);
		}

		this.pixels = newPixels;
	}
}
