/********************************************************************************
*	NOTICE:														*
*																*
*	This code is believed by the author to be bug free.  You are free to use	*
*	and modify this code with the understanding that any use, either direct	*
*	or derivative, must contain acknowledgement of its author and source.		*
*	The author makes no warranty of any kind, expressed or implied, of		*
*	merchantability or fitness for a particular purpose.  The author shall	*
*	not be held liable for any incidental or consequential damages in		*
*	connection with or arising out of the furnishing, performance, or use of	*
*	this software.  This software is not authorized for use in life support	*
*	devices or systems.												*
*																*
********************************************************************************/

// AIPP software developed by Gianluca Di Pasqua, John Oh, and Sean Hanley
// in association with the DSP Lab at the University of Toronto, 2000.

import java.awt.*;
import java.awt.image.*;
import java.io.*;

// White Impulsive Noise Generator
public class w_noise extends noiseFilter
{
	double variance;
	
	// Create object and initialize data
	public w_noise(float var)
	{
		variance = var*10;
	}
		
	// Runs the algorithm
	public void performEffect()
	{		
		int Range = 255;
		int finalnoiseR = 0;
		int finalnoiseG = 0;
		int finalnoiseB = 0;
		int pointOffset = 0;
		int[] newPixels = new int[width*height];
		
		// Moves through the input array pixel by pixel
		for(int i=0;i<height;i++)
		{
			for(int j=0;j<width;j++)
			{
				// Location of current pixel
				pointOffset = i*width+j;
				
				// Creates white impulsive noise based on variance and a
				// random number
				if ((Math.random()*1000) < variance)
				{
					finalnoiseR = 255;
					finalnoiseG = 255;
					finalnoiseB = 255;
				}
				else
				{
					finalnoiseR = (int)((pixels[pointOffset] >> 16)&0xff);
					finalnoiseG = (int)((pixels[pointOffset] >> 8)&0xff);
					finalnoiseB = (int)((pixels[pointOffset])&0xff);
				}

				newPixels[pointOffset] = (255<<24)|(finalnoiseR<<16)|(finalnoiseG<<8)|(finalnoiseB);
			}
		}
		this.pixels = newPixels;
	}

	
}
